<template>
  <SinglePane class="baseprices-files-list">
    <div class="baseprices-files-list__tabs">
      <ObTabs
        v-model="currentTab"
        :items="tabsItems"
        :no-border="true"
        value-exp="type"
        data-qa="basepricesFilesListTabs"
      />
    </div>
    <ObTable
      :columns="columns"
      :functionalPanel="true"
      :show-add-button="true"
      add-button-text="Добавить"
      :remote-opt="{
        method: getBasePricesFiles
      }"
      :remote-trigger="currentTab.type"
      :rowClassFunc="getRowClass"
      data-qa="basepricesListTable"
      @add="onAddImportFile"
      @select="onSelection"
      ref="BasePriceImportTable"
      is-fixed-header
    >
      <template slot="extraFuncButtons">
        <ObSwitcher
          label-right="Показать только активные"
          v-model="hideInactive"
          @on-change="onlyActive"
        />
      </template>
      <template v-slot:check="{ data }">
        <span class="active-icon" v-if="data.item.activated_at">
          <i class="icon checked-mini"></i>
        </span>
      </template>
      <template v-slot:date-time="{ data }">
        <div class="load-date" :class="{ 'color-gray': !data.item.activated_at }">
          {{ data.item.date_download | date('DD.MM.YYYY') }}
        </div>
        <div class="load-time">
          {{ data.item.date_download | date('HH:mm') }}
        </div>
      </template>
      <template v-slot:date-activation-time="{ data }">
        <div v-if="data.item.activated_at">
          <div class="load-date" :class="{ 'color-gray': !data.item.activated_at }">
            {{ data.item.activated_at | date('DD.MM.YYYY') }}
          </div>
          <div class="load-time">
            {{ data.item.activated_at | date('HH:mm') }}
          </div>
        </div>
      </template>
      <template v-slot:status="{ data }">
        <div v-if="data.item.curStatus" :class="data.item.activated_at ? 'color-active' : 'color-gray'">
          {{ fileStatus[data.item.curStatus] }}
        </div>
      </template>
      <template slot="noneContent">
        <div class="title">Ничего не найдено</div>
      </template>
    </ObTable>
    <ob-modal
      ref="basePriceDataImportModal"
      :title="modalTitle"
      custom-class="modal-medium"
    >
      <BasePriceImportModalForm
        :type="formType"
        @close="closeEditPopup"
        @save="onEditSave"
      />
    </ob-modal>
    <ob-modal
      ref="BasePriceImportViewFileModal"
      title="Просмотр"
      custom-class="modal-medium"
    >
      <BasePriceImportViewFile
        :file-data="fileData"
        @close="closeViewPopup"
        @activate="onActivate"
        @download="downloadFile"
      />
    </ob-modal>
  </SinglePane>
</template>

<script>
import api from '@/api';
import { getTokenData } from '@/tokenData';
import BasePriceImportModalForm from './modal/index';
import BasePriceImportViewFile from './modal/view';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTabs from 'common-components/src/obComponents/obTabs';
import ObTable from 'common-components/src/obComponents/obTable';
import ObModal from 'common-components/src/obComponents/obModal';
import ObSwitcher from "common-components/src/obComponents/obSwitcher";
import { fileStatus } from "@/constants/basePrice.js";

const tokenData = { ...getTokenData() }

export default {
  name: 'basePricesDataImport',

  components: {
    SinglePane,
    ObTabs,
    ObTable,
    ObSwitcher,
    BasePriceImportModalForm,
    BasePriceImportViewFile,
    ObModal,
  },
  data() {
    return {
      fileStatus,
      orderField: 'UPDATED_AT',
      orderDirection: 'DESC',
      hideInactive: false,
      modalTitle: 'Импорт файла',
      api,
      tabsItems: [
        {
          type: 'ORDERS',
          title: 'Импорт заказов',
          modalTitle: 'Импорт файла заказов',
        },
        {
          type: 'EXPERT_VALUES',
          title: 'Импорт экспертного значения',
          modalTitle: 'Импорт файла экспертного значения',
        },
        {
          type: 'FIXED_VALUES',
          title: 'Импорт фиксированного значения',
          modalTitle: 'Импорт файла фиксированного значения',
        }
      ],
      currentTab: {type: this.$route.query.tab || 'ORDERS'},
      activeItem: '',
      fileData: {},
      formType: 'ORDERS',
      usersInfo: [],
    }
  },

  watch: {
    currentTab: {
      handler(tab) {
        if (this.$route.query.tab !== tab.type)
          this.$router.replace({ query: { tab: tab.type } })
      },
      deep: true,
      immediate: true
    }
  },

  computed: {
    curUserUuid(){
      return tokenData.user_uuid
    },
    columns () {
      return [
        {
          title: '',
          key: 'check',
          slotName: 'check',
        },
        {
          title: '№ Загрузки',
          key: 'number',
          width: 80
        },
        {
          title: 'Наименование загрузки',
          key: 'title',
          width: 300,
        },
        {
          title: 'Имя файла',
          key: 'file_name',
          width: 130,
          html: (field) => `<span class="link" >${field.file_name}</span>`,
          action: (field) => {
            this.downloadFile(field.file_uuid);
          },
        },
        {
          title: 'Файл с пометками',
          key: 'processed_file_uuid',
          width: 70,
          html: () => {
            return `<span class="processed-file">
                      <i class="icon excel"></i>
                    </span>`
          },
          action: (field) => {
            this.downloadFile(field.processed_file_uuid);
          },
        },
        {
          title: 'Строк всего',
          key: 'strings_count',
          width: 40,
        },
        {
          title: 'Загружено успешно',
          key: 'strings_count_good',
          width: 60,
        },
        {
          title: 'Отброшено строк',
          key: 'strings_count_bad',
          width: 60,
        },
        {
          title: 'Загружено',
          key: 'date_download',
          width: 130,
          slotName: 'date-time'
        },
        {
          title: 'Автор',
          key: 'userInfo',
          width: 130,
        },
        {
          title: 'Активировано',
          key: 'activated_at',
          width: 80,
          slotName: 'date-activation-time'
        },
        {
          title: 'Статус',
          key: 'curStatus',
          width: 80,
          slotName: 'status'
        },
      ]
    }
  },

  async created() {
    /*
    for (let item of this.tabsItems) {
      const count = await api.base_prices_data_import.getListFiles({author_uuid: this.curUserUuid, type: item.type})
      item.title += ` ${count.total}`
    }
    */
  },

  methods: {
    async getBasePricesFiles({ author_uuid = this.curUserUuid, type = this.$route.query.tab || 'ORDERS', page, size, sort, query }) {
      if (sort) {
        const field = sort.split(',')[0];
        if (field === 'title') {
          this.orderDirection = sort.split(',')[1].toUpperCase();
          this.orderField = 'TITLE'
        } else if (field === 'file_name') {
          this.orderDirection = sort.split(',')[1].toUpperCase();
          this.orderField = 'FILE_NAME'
        } else if (field === 'date_download') {
          this.orderDirection = sort.split(',')[1].toUpperCase();
          this.orderField = 'DATE_DOWNLOAD'
        }
      }
      try {
        let data = await api.base_prices_data_import.getListFiles({ author_uuid, type, page_number: page, page_size: size, order_field: this.orderField, order_direction: this.orderDirection, query })

        if( this.hideInactive ) { // когда будет готов бэк, перенести эту проверку в запрос
          data.content = data.content.filter(item => item.activated_at != null);
        }

        if (data.content.length) {
          let authorUuids = [];
          // выделяем уникальных author_uuid, для запроса по ним данных
          data.content.filter((e, i ,a) => {
            let res = a.findIndex((t) => t.author_uuid === e.author_uuid) === i;
            if (res) {
              authorUuids.push(data.content[i].author_uuid)
            }
            return res;
          });
          let usersInfo = await api.adminPanel.users.getUsersInfo(authorUuids)
          if (usersInfo.list.length) {
            this.usersInfo = usersInfo.list;
          }
          // форматируем и дополняем данные
          data.content = data.content.map((item) => {
            return {
              ...item,
              userInfo: this.getUserInfo(item.author_uuid),
            }
          })
        }

        return data;

      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    getUserInfo(userUuid) {
      if (this.usersInfo.length) {
        let userData = this.usersInfo.find(user => user.uuid === userUuid);
        if (userData) {
          return userData.firstname + ' ' + userData.lastname;
        }
      }
      return 'Не найден';
    },
    onAddImportFile() {
      this.selectedData = {};
      this.formType = this.$route.query.tab;
      let formTitle = this.tabsItems.find(tab => tab.type === this.formType).modalTitle;
      if( formTitle ) {
        this.modalTitle = formTitle;
      }
      this.$refs.basePriceDataImportModal.open();
    },
    onSelection(data) {
      this.fileData = data;
      this.$refs.BasePriceImportViewFileModal.open();
    },
    closeEditPopup () {
      this.$refs.basePriceDataImportModal.close();
    },
    closeViewPopup () {
      this.selectedData = {};
      this.$refs.BasePriceImportViewFileModal.close();
    },
    onActivate () {
      this.selectedData = {};
      this.$refs.BasePriceImportViewFileModal.close();
      this.$refs.BasePriceImportTable.loadData()
    },
    onEditSave () {
      this.closeEditPopup();
      this.$refs.BasePriceImportTable.loadData();
    },
    async downloadFile (uuid) {
      try {
        await api.files.getFile(uuid, true)
        this.$notification({
          type: 'system_notification_success',
          message: `Файл успешно загружен`
        })
      } catch (e) {
        this.$notification({
            type: 'system_notification_error',
            message: `Ошибка загрузки файла`
        })
      }
    },
    onlyActive () {
      this.$refs.BasePriceImportTable.loadData();
    },
    getRowClass (data) {
      return data.item.activated_at ? '' : 'row-gray'
    }
  },
}
</script>

<style lang="scss" scoped>
.baseprices-files-list {
  .container {
    width: auto;
  }

  &::v-deep {
    .ob-func-panel {
      &__control-row {
        background-color: transparent;
      }
    }
    .ob-tabs__sliding-line {
      bottom: 0;
    }

    .ob-table-inner {
      z-index: 1;
    }

    td > .td-container {
      padding: 20px 18px;
      min-height: auto;
    }

    td:nth-child(5) > .td-container ,
    td:nth-child(6) > .td-container ,
    td:nth-child(7) > .td-container ,
    td:nth-child(8) > .td-container {
      display: flex;
      justify-content: center;
    }

    .link{
      color: $blue-dust;
      cursor: pointer;
    }

    .processed-file{
      cursor: pointer;
    }

    .processed-file i{
      font-size: 16px;
      color: $blue-dust;
    }

    .first-col{
      position: relative;
      & > i {
        position: absolute;
      }
      & > div{
        margin-left: 35px;
      }
    }

    .row-gray .td-container{
      color: $gray-slate;
    }
  }

  &__tabs {
    padding: 20px 20px 0 20px;
    position: relative;
    box-shadow: 0px 2px 10px rgba(0, 75, 200, 0.15);
    z-index: 100;
  }

  .active-icon i {
    font-size: 16px;
    color: $green-craiola;
  }

  .load-date{
    //color: $cobalt-black;
  }

  .load-time{
    color: $gray-slate;
  }

  .color-gray{
    color: $gray-slate;
  }

}
</style>